# Booking Form

Generally, [bookable products](/traveler/payments.md#payment-strategies) require some information about the user and or the individuals attending. Once the user has selected all the passes they are interested in, you must fetch a  `BookingForm` and provide an interface for the user to complete this form.

Note that the `Pass`es in the arguments is a flattened array of `Pass`es. For example if the user requires two of a single pass (i.e. two adult passes) then the array holds two of the same `Pass` type.

{% tabs %}
{% tab title="iOS" %}

```swift
Traveler.fetchBookingForm(product: catalogItemDetails,
                           passes: selectedPasses) { (form, error) in

}
```

Alternatively you can use the delegate pattern

```swift
Traveler.fetchBookingForm(product: catalogItemDetails,
                           passes: selectedPasses,
                         delegate: self)
```

```swift
extension MyViewController: BookingFormFetchDelegate {
    func bookingFormFetchDidFailWith(_ error: Error) {
    
    }
    
    func bookingFormFetchDidSucceedWith(_ bookingForm: BookingForm) {
    
    }
}
```

{% endtab %}

{% tab title="Android" %}

```java
Traveler.fetchBookingForm(catalogItemDetail, passes, new FetchBookingFormCallback() {
    @Override
    void onBookingFormFetchSuccess(BookingForm bookingForm) {
    
    }
    
    @Override
    void onBookingFormFetchError(Error error) {
    
    }
});
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.guestlogix.io/traveler/mobile-sdks/stripe-payment-sdk/booking-form.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
